//
//  TNMapViewController.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/17/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNMapViewController.h"
#import "TNOffer.h"
#import "TNBusiness.h"


@implementation TNMapViewController

- (id)initWithOffer:(TNOffer *)off {
    if ((self = [super init])) {
        offer = [off retain];
        [[self navigationItem] setTitle:NSLocalizedString(@"Map", @"")];
    }
    return self;
}

- (void)dealloc {
    [mapView release];
    [super dealloc];
}

#pragma mark UIViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    mapView = [[MKMapView alloc] initWithFrame:CGRectMake(0, 0, [[self view] bounds].size.width, [[self view] bounds].size.height)];
    [mapView setDelegate:self];
    
    MKPointAnnotation *ann = [[[MKPointAnnotation alloc] init] autorelease];
    [ann setCoordinate:[[offer location] coordinate]];
    [ann setTitle:[[offer business] name]];
    [mapView addAnnotation:ann];
    
    [mapView setRegion:MKCoordinateRegionMake([ann coordinate], MKCoordinateSpanMake(0.01, 0.01))];
    
    [[self view] addSubview:mapView];
}

- (void)viewDidUnload {
    [super viewDidUnload];
    [mapView release], mapView = nil;
}

#pragma mark MKMapViewDelegate

- (void)mapView:(MKMapView *)mv didAddAnnotationViews:(NSArray *)views {
    [mapView selectAnnotation:[[views objectAtIndex:0] annotation] animated:YES];
}

@end
