//
//  OfferViewController.h
//  ThinkNear
//
//  Created by Adam Ernst on 3/11/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>


@class TNOffer;
@class TNClaim;
@class MBProgressHUD;
@class TNClaimRequestOperation;
@class TNOfferRequestOperation;


@interface TNOfferViewController : UITableViewController <UIAlertViewDelegate> {
    TNClaim *claim;
    TNOffer *offer;
    CLLocation *location;
    
    UILabel *titleLabel;
    UILabel *descriptionLabel;
    UIButton *claimButton;
    UILabel *codeLabel;
    UIView *offerView;
    UIImageView *offerBackground;
    UIView *codeSection;
    UILabel *discountLabel;
    UILabel *expirationLabel;
    UILabel *timeRemainingLabel;
    UITableViewCell *mapCell;
    UITableViewCell *phoneCell;
    UILabel *addressLabel;
    UILabel *phoneLabel;
    
    MBProgressHUD *hud;
    TNClaimRequestOperation *claimOperation;
	TNOfferRequestOperation *offerRequestOperation;
    
    NSTimer *expirationTimer;
}

- (id)initWithOffer:(TNOffer *)off location:(CLLocation *)location;
- (id)initWithClaim:(TNClaim *)off;

@property (nonatomic, retain) IBOutlet UILabel *titleLabel;
@property (nonatomic, retain) IBOutlet UILabel *descriptionLabel;
@property (nonatomic, retain) IBOutlet UILabel *codeLabel;
@property (nonatomic, retain) IBOutlet UIView *offerView;
@property (nonatomic, retain) IBOutlet UIImageView *offerBackground;
@property (nonatomic, retain) IBOutlet UIView *codeSection;
@property (nonatomic, retain) IBOutlet UILabel *discountLabel;
@property (nonatomic, retain) IBOutlet UILabel *expirationLabel;
@property (nonatomic, retain) IBOutlet UILabel *timeRemainingLabel;

@property (nonatomic, retain) IBOutlet UITableViewCell *mapCell;
@property (nonatomic, retain) IBOutlet UITableViewCell *phoneCell;
@property (nonatomic, retain) IBOutlet UILabel *addressLabel;
@property (nonatomic, retain) IBOutlet UILabel *phoneLabel;


- (IBAction)claim:(id)sender;

@end
