//
//  TNSaveOfferViewController.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/25/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNSaveOfferViewController.h"
#import "TNOffer.h"
#import "MBProgressHUD.h"
#import "TNSaveOfferRequestOperation.h"


@implementation TNSaveOfferViewController
@synthesize emailField;

- (id)initWithOffer:(TNOffer *)off {
    if ((self = [super initWithNibName:@"SaveOffer" bundle:nil])) {
        offer = [off retain];
        
        [[self navigationItem] setTitle:NSLocalizedString(@"Email", @"")];
    }
    return self;
}

- (void)dealloc {
    [offer release];
    
    [emailField release];
    
    [hud release];
    [saveOperation release];
    
    [super dealloc];
}

- (void)viewDidLoad {
    [[self view] setBackgroundColor:[UIColor colorWithPatternImage:[UIImage imageNamed:@"splash.png"]]];
    [super viewDidLoad];
}

- (void)viewDidUnload {
    [self setEmailField:nil];
    [super viewDidUnload];
}

- (void)viewWillAppear:(BOOL)animated {
    [[self emailField] becomeFirstResponder];
}

- (IBAction)send {
    hud = [[MBProgressHUD alloc] initWithView:[self view]];
    [[self view] addSubview:hud];
    [hud setLabelText:NSLocalizedString(@"Saving offer…", @"")];
    [hud show:YES];
    
    [[self emailField] setEnabled:NO];
    
    saveOperation = [[TNSaveOfferRequestOperation alloc] initWithOffer:offer email:[[self emailField] text]];
    [saveOperation setCompletionBlock:^{
        [self performSelectorOnMainThread:@selector(saveOperationCompleted) withObject:nil waitUntilDone:NO];
    }];
    [saveOperation start];
}

- (void)saveOperationCompleted {
    if ([saveOperation error]) {
        [hud hide:NO];
        
        [[[[UIAlertView alloc] initWithTitle:[[saveOperation error] localizedDescription] 
                                     message:nil 
                                    delegate:nil 
                           cancelButtonTitle:NSLocalizedString(@"OK", @"") 
                           otherButtonTitles:nil] autorelease] show];
        [[self emailField] setEnabled:YES];
    } else {
        [hud setCustomView:[[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"claimed.png"]] autorelease]];
        [hud setMode:MBProgressHUDModeCustomView];
        [hud setLabelText:@"Saved!"];
        [self performSelector:@selector(hideHud) withObject:nil afterDelay:1.0];
    }
}

@end
