//
//  TNButton.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/24/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNButton.h"


@implementation TNButton

+ (TNButton *)buttonWithColor:(TNButtonColor)color {
    UIImage *backgroundImage;
    switch (color) {
        case TNButtonColorBlack:
            backgroundImage = [UIImage imageNamed:@"black_button.png"];
            break;
        case TNButtonColorRed:
            backgroundImage = [UIImage imageNamed:@"red_button.png"];
            break;
        default:
            assert(0);
    }
    
    TNButton *b = [[[TNButton alloc] initWithFrame:CGRectMake(0, 0, 60, [backgroundImage size].height)] autorelease];
    [b setBackgroundImage:[backgroundImage stretchableImageWithLeftCapWidth:12 topCapHeight:0] forState:UIControlStateNormal];
    [[b titleLabel] setTextColor:[UIColor whiteColor]];
    [[b titleLabel] setFont:[UIFont boldSystemFontOfSize:15]];
    [b setContentEdgeInsets:UIEdgeInsetsMake(0, 10, 0, 10)];
    return b;
}

@end
