//
//  TNBusiness.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/11/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNBusiness.h"
#import "TNHelper.h"


@implementation TNBusiness

@synthesize name, phone;
@synthesize address1, address2, city, state, zip;

- (id)initWithJSONDictionary:(NSDictionary *)dict {
    if ((self = [super init])) {
        name = [[dict objectForKey:@"name"] retain];
        phone = [[dict objectForKey:@"phone"] retain];
        
        NSDictionary *addr = [dict objectForKey:@"address"];
        address1 = [[addr objectForKey:@"address_1"] retain];
        address2 = [[addr objectForKey:@"address_2"] retain];
        city = [[addr objectForKey:@"city"] retain];
        state = [[addr objectForKey:@"state"] retain];
        zip = [[addr objectForKey:@"zip"] retain];
    }
    return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder {
    if ((self = [super init])) {
        name = [[aDecoder decodeObjectForKey:@"name"] retain];
        phone = [[aDecoder decodeObjectForKey:@"phone"] retain];
        
        address1 = [[aDecoder decodeObjectForKey:@"address1"] retain];
        address2 = [[aDecoder decodeObjectForKey:@"address2"] retain];
        city = [[aDecoder decodeObjectForKey:@"city"] retain];
        state = [[aDecoder decodeObjectForKey:@"state"] retain];
        zip = [[aDecoder decodeObjectForKey:@"zip"] retain];
    }
    return self;
}

- (void)dealloc {
    [name release];
    [phone release];
    
    [address1 release];
    [address2 release];
    [city release];
    [state release];
    [zip release];
    
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)aCoder {
    [aCoder encodeObject:name forKey:@"name"];
    [aCoder encodeObject:phone forKey:@"phone"];
    
    [aCoder encodeObject:address1 forKey:@"address1"];
    [aCoder encodeObject:address2 forKey:@"address2"];
    [aCoder encodeObject:city forKey:@"city"];
    [aCoder encodeObject:state forKey:@"state"];
    [aCoder encodeObject:zip forKey:@"zip"];
}

@end
