//
//  TNClaim.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/7/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNClaim.h"
#import "TNOffer.h"


@implementation TNClaim

@synthesize offer, code, expirationDate;

- (id)initWithJSONDictionary:(NSDictionary *)dict {
    if ((self = [super init])) {
        NSDictionary *off = [dict objectForKey:@"offer"];
        NSDictionary *claim = [off objectForKey:@"claim"];
        code = [[claim objectForKey:@"code"] retain];
        
        offer = [[TNOffer alloc] initWithJSONDictionary:dict];
    }
    return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder {
    if ((self = [super init])) {
        offer = [[aDecoder decodeObjectForKey:@"offer"] retain];
        code = [[aDecoder decodeObjectForKey:@"code"] retain];
    }
    return self;
}

- (void)dealloc {
    [offer release];
    [code release];
    [expirationDate release];
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)aCoder {
    [aCoder encodeObject:offer forKey:@"offer"];
    [aCoder encodeObject:code forKey:@"code"];
}

@end
