//
//  TNClaimRequestOperation.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/7/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNClaimRequestOperation.h"
#import "TNOffer.h"
#import "TNHelper.h"
#import "TNClaim.h"


@implementation TNClaimRequestOperation

@synthesize claim;

- (id)initWithOffer:(TNOffer *)off location:(CLLocation *)loc {
    if ((self = [super init])) {
        offer = [off retain];
        location = [loc retain];
    }
    return self;
}

- (void)dealloc {
    [offer release];
    [location release];
    [claim release];
    [super dealloc];
}

#pragma mark Abstract Methods

- (OAMutableURLRequest *)request {
    NSNumberFormatter *f = [TNHelper APINumberFormatter];
    CLLocationCoordinate2D coord = [location coordinate];
    
    NSString *url = [NSString stringWithFormat:@"/offers/%@/claim/%@,%@.json", 
                     [TNHelper URLEncode:[offer identifier]],
                     [f stringFromNumber:[NSNumber numberWithDouble:coord.latitude]],
                     [f stringFromNumber:[NSNumber numberWithDouble:coord.longitude]]];
    OAMutableURLRequest *req = [self JSONRequestWithRelativeURL:url];
    [req setHTTPMethod:@"POST"];
    return req;
}

- (void)handleResponse:(NSHTTPURLResponse *)response data:(id)jsonData {
    [self willChangeValueForKey:@"claim"];
    claim = [[TNClaim alloc] initWithJSONDictionary:jsonData];
    [self didChangeValueForKey:@"claim"];
    
    [self finishWithError:nil];
}

@end
