//
//  TNHelper.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/9/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNHelper.h"


@implementation TNHelper

+ (NSString *)URLQueryStringFromDictionary:(NSDictionary *)dict {
    NSMutableArray *pairs = [NSMutableArray array];
    for (id key in dict) {
        [pairs addObject:[NSString stringWithFormat:@"%@=%@",
                          [TNHelper URLEncode:key],
                          [TNHelper URLEncode:[dict objectForKey:key]]]];
    }
    return [pairs componentsJoinedByString:@"&"];
}

+ (NSString *)URLEncode:(NSString *)str {
    CFStringRef encoded = 
    CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                            (CFStringRef)str,
                                            NULL,
                                            (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                            kCFStringEncodingUTF8);
    return [(NSString *)encoded autorelease];
}

static NSNumberFormatter *APINumberFormatter = nil;
+ (NSNumberFormatter *)APINumberFormatter {
    if (APINumberFormatter == nil) {
        APINumberFormatter = [[NSNumberFormatter alloc] init];
        [APINumberFormatter setLocale:[[[NSLocale alloc] initWithLocaleIdentifier:@"en_US"] autorelease]];
        [APINumberFormatter setPositiveFormat:@"00.0000"];
        [APINumberFormatter setNegativeFormat:@"-00.0000"];
    }
    return APINumberFormatter;
}

static NSDateFormatter *APIDateFormatter = nil;
+ (NSDateFormatter *)APIDateFormatter {
    if (APIDateFormatter == nil) {
        APIDateFormatter = [[NSDateFormatter alloc] init];
        [APIDateFormatter setTimeZone:[NSTimeZone timeZoneWithAbbreviation:@"UTC"]];
        [APIDateFormatter setDateFormat:@"yyyy-MM-dd'T'HH:mm:ss'Z'"];
    }
    return APIDateFormatter;
}

@end
