//
//  TNOfferRequestOperation.m
//  ThinkNear
//
//  Created by Adam Ernst on 3/7/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNOfferRequestOperation.h"
#import "TNHelper.h"
#import "TNOffer.h"


@implementation TNOfferRequestOperation

@synthesize offer;

- (id)initWithOfferId:(NSString *)offId {
    if ((self = [super init])) {
        offerId = [offId copy];
    }
    return self;
}

- (void)dealloc {
    [offerId release];
    [offer release];
    [super dealloc];
}

#pragma mark TNRequestOperation

- (OAMutableURLRequest *)request {
    return [self JSONRequestWithRelativeURL:[NSString stringWithFormat:@"/offers/%@.json", 
                                             [TNHelper URLEncode:offerId]]];
}

- (void)handleResponse:(NSHTTPURLResponse *)response data:(id)jsonData {
    [self willChangeValueForKey:@"offer"];
    offer = [[TNOffer alloc] initWithJSONDictionary:jsonData];
    [self didChangeValueForKey:@"offer"];
    [self finishWithError:nil];
}

@end
