//
//  TNRequestOperation.h
//  ThinkNear
//
//  Created by Adam Ernst on 3/7/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "OAMutableURLRequest.h"


extern NSString *TNRequestOperationErrorDomain;
enum {
    TNRequestOperationErrorInvalidAuth,
    TNRequestOperationErrorUnexpectedStatusCode,
    TNRequestOperationErrorNotJson,
};


@interface TNRequestOperation : NSOperation {
@private
    BOOL finished;
    NSURLConnection *connection;
    NSHTTPURLResponse *response;
    NSMutableData *data;
    NSError *error;
}

- (NSError *)error;

@end

@interface TNRequestOperation (ProtectedMethods)
- (NSString *)endpointURL;
- (OAMutableURLRequest *)JSONRequestWithRelativeURL:(NSString *)url;
- (void)finishWithError:(NSError *)err;
@end