//
//  TNSaveOfferRequestOperation.m
//  ThinkNear
//
//  Created by Adam Ernst on 4/4/11.
//  Copyright 2011 cosmicsoft. All rights reserved.
//

#import "TNSaveOfferRequestOperation.h"
#import "TNOffer.h"
#import "TNHelper.h"


@implementation TNSaveOfferRequestOperation

- (id)initWithOffer:(TNOffer *)off email:(NSString *)e {
    if ((self = [super init])) {
        offer = [off retain];
        email = [e copy];
    }
    return self;
}

- (void)dealloc {
    [offer release];
    [email release];
    [super dealloc];
}

#pragma mark Abstract Methods

- (OAMutableURLRequest *)request {
    NSString *url = [NSString stringWithFormat:@"/offers/%@/save.json?email=%@", 
                     [TNHelper URLEncode:[offer identifier]],
                     [TNHelper URLEncode:email]];
    OAMutableURLRequest *req = [self JSONRequestWithRelativeURL:url];
    [req setHTTPMethod:@"POST"];
    return req;
}

- (void)handleResponse:(NSHTTPURLResponse *)response data:(id)jsonData {
    [self finishWithError:nil];
}

@end
